# buffers
SET SESSION myisam_sort_buffer_size = 16*1024*1024;
SET SESSION bulk_insert_buffer_size =  8*1024*1024;

# bb_config
REPLACE INTO `bb_config` VALUES ('tp_version', '1.0.1.1');
REPLACE INTO `bb_config` VALUES ('tp_release_date', '2009-01-24');
REPLACE INTO `bb_config` VALUES ('tp_release_state', 'svn beta');

# countries hack
ALTER TABLE `bb_users` CHANGE `user_from_flag` `user_from_flag` VARCHAR( 3 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

CREATE TABLE IF NOT EXISTS `bb_countries` (
  `country_id` mediumint(3) NOT NULL auto_increment,
  `country_code` varchar(3) NOT NULL default '0',
  `country_code2` varchar(2) NOT NULL,
  `country_code3` varchar(3) NOT NULL,
  PRIMARY KEY  (`country_id`),
  KEY `country_code2` (`country_code2`),
  KEY `country_code3` (`country_code3`),
  KEY `country_code` (`country_code`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=245 ;

INSERT INTO `bb_countries` (`country_id`, `country_code`, `country_code2`, `country_code3`) VALUES
(1, '036', 'AU', 'AUS'),
(2, '040', 'AT', 'AUT'),
(3, '031', 'AZ', 'AZE'),
(4, '248', 'AX', 'ALA'),
(5, '008', 'AL', 'ALB'),
(6, '012', 'DZ', 'DZA'),
(7, '581', 'UM', 'UMI'),
(8, '850', 'VI', 'VIR'),
(9, '016', 'AS', 'ASM'),
(10, '660', 'AI', 'AIA'),
(11, '024', 'AO', 'AGO'),
(12, '020', 'AD', 'AND'),
(13, '010', 'AQ', 'ATA'),
(14, '028', 'AG', 'ATG'),
(15, '032', 'AR', 'ARG'),
(16, '051', 'AM', 'ARM'),
(17, '533', 'AW', 'ABW'),
(18, '004', 'AF', 'AFG'),
(19, '044', 'BS', 'BHS'),
(20, '050', 'BD', 'BGD'),
(21, '052', 'BB', 'BRB'),
(22, '048', 'BH', 'BHR'),
(23, '084', 'BZ', 'BLZ'),
(24, '112', 'BY', 'BLR'),
(25, '056', 'BE', 'BEL'),
(26, '204', 'BJ', 'BEN'),
(27, '060', 'BM', 'BMU'),
(28, '100', 'BG', 'BGR'),
(29, '068', 'BO', 'BOL'),
(30, '070', 'BA', 'BIH'),
(31, '072', 'BW', 'BWA'),
(32, '076', 'BR', 'BRA'),
(33, '086', 'IO', 'IOT'),
(34, '092', 'VG', 'VGB'),
(35, '096', 'BN', 'BRN'),
(36, '854', 'BF', 'BFA'),
(37, '108', 'BI', 'BDI'),
(38, '064', 'BT', 'BTN'),
(39, '548', 'VU', 'VUT'),
(40, '336', 'VA', 'VAT'),
(41, '826', 'GB', 'GBR'),
(42, '348', 'HU', 'HUN'),
(43, '862', 'VE', 'VEN'),
(44, '626', 'TL', 'TLS'),
(45, '704', 'VN', 'VNM'),
(46, '266', 'GA', 'GAB'),
(47, '332', 'HT', 'HTI'),
(48, '328', 'GY', 'GUY'),
(49, '270', 'GM', 'GMB'),
(50, '288', 'GH', 'GHA'),
(51, '312', 'GP', 'GLP'),
(52, '320', 'GT', 'GTM'),
(53, '324', 'GN', 'GIN'),
(54, '624', 'GW', 'GNB'),
(55, '276', 'DE', 'DEU'),
(56, '292', 'GI', 'GIB'),
(57, '340', 'HN', 'HND'),
(58, '344', 'HK', 'HKG'),
(59, '308', 'GD', 'GRD'),
(60, '304', 'GL', 'GRL'),
(61, '300', 'GR', 'GRC'),
(62, '268', 'GE', 'GEO'),
(63, '316', 'GU', 'GUM'),
(64, '208', 'DK', 'DNK'),
(65, '180', 'CD', 'COD'),
(66, '262', 'DJ', 'DJI'),
(67, '212', 'DM', 'DMA'),
(68, '214', 'DO', 'DOM'),
(69, 'EU', 'EU', ''),
(70, '818', 'EG', 'EGY'),
(71, '894', 'ZM', 'ZMB'),
(72, '732', 'EH', 'ESH'),
(73, '716', 'ZW', 'ZWE'),
(74, '376', 'IL', 'ISR'),
(75, '356', 'IN', 'IND'),
(76, '360', 'ID', 'IDN'),
(77, '400', 'JO', 'JOR'),
(78, '368', 'IQ', 'IRQ'),
(79, '364', 'IR', 'IRN'),
(80, '372', 'IE', 'IRL'),
(81, '352', 'IS', 'ISL'),
(82, '724', 'ES', 'ESP'),
(83, '380', 'IT', 'ITA'),
(84, '887', 'YE', 'YEM'),
(85, '408', 'KP', 'PRK'),
(86, '132', 'CV', 'CPV'),
(87, '398', 'KZ', 'KAZ'),
(88, '136', 'KY', 'CYM'),
(89, '116', 'KH', 'KHM'),
(90, '120', 'CM', 'CMR'),
(91, '124', 'CA', 'CAN'),
(92, '634', 'QA', 'QAT'),
(93, '404', 'KE', 'KEN'),
(94, '196', 'CY', 'CYP'),
(95, '417', 'KG', 'KGZ'),
(96, '296', 'KI', 'KIR'),
(97, '156', 'CN', 'CHN'),
(98, '166', 'CC', 'CCK'),
(99, '170', 'CO', 'COL'),
(100, '174', 'KM', 'COM'),
(101, '188', 'CR', 'CRI'),
(102, '384', 'CI', 'CIV'),
(103, '192', 'CU', 'CUB'),
(104, '414', 'KW', 'KWT'),
(105, '418', 'LA', 'LAO'),
(106, '428', 'LV', 'LVA'),
(107, '426', 'LS', 'LSO'),
(108, '430', 'LR', 'LBR'),
(109, '422', 'LB', 'LBN'),
(110, '434', 'LY', 'LBY'),
(111, '440', 'LT', 'LTU'),
(112, '438', 'LI', 'LIE'),
(113, '442', 'LU', 'LUX'),
(114, '480', 'MU', 'MUS'),
(115, '478', 'MR', 'MRT'),
(116, '450', 'MG', 'MDG'),
(117, '175', 'YT', 'MYT'),
(118, '446', 'MO', 'MAC'),
(119, '807', 'MK', 'MKD'),
(120, '454', 'MW', 'MWI'),
(121, '458', 'MY', 'MYS'),
(122, '466', 'ML', 'MLI'),
(123, '462', 'MV', 'MDV'),
(124, '470', 'MT', 'MLT'),
(125, '504', 'MA', 'MAR'),
(126, '474', 'MQ', 'MTQ'),
(127, '584', 'MH', 'MHL'),
(128, '484', 'MX', 'MEX'),
(129, '508', 'MZ', 'MOZ'),
(130, '498', 'MD', 'MDA'),
(131, '492', 'MC', 'MCO'),
(132, '496', 'MN', 'MNG'),
(133, '500', 'MS', 'MSR'),
(134, '104', 'MM', 'MMR'),
(135, '516', 'NA', 'NAM'),
(136, '520', 'NR', 'NRU'),
(137, '524', 'NP', 'NPL'),
(138, '562', 'NE', 'NER'),
(139, '566', 'NG', 'NGA'),
(140, '530', 'AN', 'ANT'),
(141, '528', 'NL', 'NLD'),
(142, '558', 'NI', 'NIC'),
(143, '570', 'NU', 'NIU'),
(144, '540', 'NC', 'NCL'),
(145, '554', 'NZ', 'NZL'),
(146, '578', 'NO', 'NOR'),
(147, '784', 'AE', 'ARE'),
(148, '512', 'OM', 'OMN'),
(149, '162', 'CX', 'CXR'),
(150, '184', 'CK', 'COK'),
(151, '334', 'HM', 'HMD'),
(152, '586', 'PK', 'PAK'),
(153, '585', 'PW', 'PLW'),
(154, '275', 'PS', 'PSE'),
(155, '591', 'PA', 'PAN'),
(156, '598', 'PG', 'PNG'),
(157, '600', 'PY', 'PRY'),
(158, '604', 'PE', 'PER'),
(159, '612', 'PN', 'PCN'),
(160, '616', 'PL', 'POL'),
(161, '620', 'PT', 'PRT'),
(162, '630', 'PR', 'PRI'),
(163, '178', 'CG', 'COG'),
(164, '638', 'RE', 'REU'),
(165, '643', 'RU', 'RUS'),
(166, '646', 'RW', 'RWA'),
(167, '642', 'RO', 'ROU'),
(168, '840', 'US', 'USA'),
(169, '222', 'SV', 'SLV'),
(170, '882', 'WS', 'WSM'),
(171, '674', 'SM', 'SMR'),
(172, '678', 'ST', 'STP'),
(173, '682', 'SA', 'SAU'),
(174, '748', 'SZ', 'SWZ'),
(175, '744', 'SJ', 'SJM'),
(176, '580', 'MP', 'MNP'),
(177, '690', 'SC', 'SYC'),
(178, '686', 'SN', 'SEN'),
(179, '670', 'VC', 'VCT'),
(180, '659', 'KN', 'KNA'),
(181, '662', 'LC', 'LCA'),
(182, '666', 'PM', 'SPM'),
(183, '688', 'RS', 'SRB'),
(184, '891', 'CS', 'SCG'),
(185, '702', 'SG', 'SGP'),
(186, '760', 'SY', 'SYR'),
(187, '703', 'SK', 'SVK'),
(188, '705', 'SI', 'SVN'),
(189, '090', 'SB', 'SLB'),
(190, '706', 'SO', 'SOM'),
(191, '736', 'SD', 'SDN'),
(192, '740', 'SR', 'SUR'),
(193, '694', 'SL', 'SLE'),
(194, '810', 'SU', 'SUN'),
(195, '762', 'TJ', 'TJK'),
(196, '764', 'TH', 'THA'),
(197, '158', 'TW', 'TWN'),
(198, '834', 'TZ', 'TZA'),
(199, '768', 'TG', 'TGO'),
(200, '772', 'TK', 'TKL'),
(201, '776', 'TO', 'TON'),
(202, '780', 'TT', 'TTO'),
(203, '798', 'TV', 'TUV'),
(204, '788', 'TN', 'TUN'),
(205, '795', 'TM', 'TKM'),
(206, '792', 'TR', 'TUR'),
(207, '800', 'UG', 'UGA'),
(208, '860', 'UZ', 'UZB'),
(209, '804', 'UA', 'UKR'),
(210, '858', 'UY', 'URY'),
(211, '234', 'FO', 'FRO'),
(212, '583', 'FM', 'FSM'),
(213, '242', 'FJ', 'FJI'),
(214, '608', 'PH', 'PHL'),
(215, '246', 'FI', 'FIN'),
(216, '238', 'FK', 'FLK'),
(217, '250', 'FR', 'FRA'),
(218, '254', 'GF', 'GUF'),
(219, '258', 'PF', 'PYF'),
(220, '260', 'TF', 'ATF'),
(221, '191', 'HR', 'HRV'),
(222, '140', 'CF', 'CAF'),
(223, '148', 'TD', 'TCD'),
(224, '499', 'ME', 'MNE'),
(225, '203', 'CZ', 'CZE'),
(226, '152', 'CL', 'CHL'),
(227, '756', 'CH', 'CHE'),
(228, '752', 'SE', 'SWE'),
(229, '144', 'LK', 'LKA'),
(230, '218', 'EC', 'ECU'),
(231, '226', 'GQ', 'GNQ'),
(232, '232', 'ER', 'ERI'),
(233, '233', 'EE', 'EST'),
(234, '231', 'ET', 'ETH'),
(235, '710', 'ZA', 'ZAF'),
(236, '410', 'KR', 'KOR'),
(237, '239', 'GS', 'SGS'),
(238, '388', 'JM', 'JAM'),
(239, '392', 'JP', 'JPN'),
(240, '074', 'BV', 'BVT'),
(241, '574', 'NF', 'NFK'),
(242, '654', 'SH', 'SHN'),
(243, '796', 'TC', 'TCA'),
(244, '876', 'WF', 'WLF');

DROP TABLE `bb_flags`;

# clear posts cache
TRUNCATE `bb_posts_html`;